#!/bin/bash
board=$(cat /etc/armbian-image-release | grep "BOARD=")
if [ "$board" == "BOARD=rb25f" ]; then
    echo "Doing the Lumidigm SEngine upgrade" | tee -a /root/upgrade/upgrade.log
    # Get filename of this version
    cd lumidigm
    filename=""
    for filename in *.tar.gz; do
        if [ ! -f "$filename" ]; then
            echo "Error cannot find the upgrade file!" | tee -a /root/upgrade/upgrade.log
            cd ..
            exit 1
        fi
        break
    done
    filename_version="${filename%".tar.gz"*}"
	tar -xf "$filename"
	cp libVCOMExample.so /usr/local/lib
	ln -fs /usr/local/lib/libVCOMExample.so /usr/local/lib/libVCOMExample.so.1
	#cp ~/upgrade/upgrade_files/debs-upgrade/libipc.so /usr/local/lib
	cd "$filename_version"
	awk '!/read/' install.sh > temp.txt && mv temp.txt install.sh
	chmod +x install.sh
	sudo ./install.sh | tee -a /root/upgrade/upgrade.log
    last_ecode="$?"
    echo "Exit status for installing lumidigm SEngine is "$last_ecode"" | tee -a /root/upgrade/upgrade.log
	ldconfig | tee -a /root/upgrade/upgrade.log
	cd ..
	rm -r "$filename_version"
    cd ..

    echo "Exit status after Lumidigm upgrade is" "$last_ecode" | tee -a /root/upgrade/upgrade.log
    exit $last_ecode
fi
